VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.ocx"
Begin VB.Form frmTreeView 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Workbooks And Worksheets"
   ClientHeight    =   3060
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   4560
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3060
   ScaleWidth      =   4560
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkCloseFormOnSelect 
      Caption         =   "&Close This Form After Select"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   2040
      Width           =   3735
   End
   Begin VB.CommandButton btnClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   495
      Left            =   2280
      TabIndex        =   2
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CommandButton btnGoto 
      Caption         =   "Go To"
      Height          =   495
      Left            =   960
      TabIndex        =   1
      Top             =   2400
      Width           =   1215
   End
   Begin MSComctlLib.TreeView tvwWorkbooks 
      Height          =   1815
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
      _ExtentX        =   7646
      _ExtentY        =   3201
      _Version        =   393217
      Style           =   6
      Appearance      =   1
   End
End
Attribute VB_Name = "frmTreeView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private pCloseNavigationAfterSelect As Variant



Private Sub btnClose_Click()
    Dim FormTop As Long
    Dim FormLeft As Long
    FormTop = Me.Top
    FormLeft = Me.Left
    
    
    If RWCreatable = False Then
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' if the user has an old version of RegistryWorx, the
        ' Root may not be creatable. This is tested during
        ' OnConnection. If we can't create RegistryWorx, we
        ' don't do any registry related stuff.
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Unload Me
        Exit Sub
    End If
    
    If RW Is Nothing Then
        Set RW = New RegistryWorx.Root
    End If
    
    If RW.RegistryValueExists(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP) = False Then
        RW.RegistryCreateValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP, ValueValue:=CLng(FormTop)
    End If
    
    If RW.RegistryValueExists(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT) = False Then
        RW.RegistryCreateValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT, ValueValue:=CLng(FormLeft)
    End If
    
    RW.RegistrySetValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP, newvalue:=FormTop
    RW.RegistrySetValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT, newvalue:=FormLeft
    

    Unload Me
End Sub

Private Sub chkCloseFormOnSelect_Click()
    If Me.chkCloseFormOnSelect.Value = 0 Then
        pCloseNavigationAfterSelect = False
    Else
        pCloseNavigationAfterSelect = True
    End If

    If RWCreatable = False Then
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' if the user has an old version of RegistryWorx, the
        ' Root may not be creatable. This is tested during
        ' OnConnection. If we can't create RegistryWorx, we
        ' don't do any registry related stuff.
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Exit Sub
    End If


    If RW Is Nothing Then
        Set RW = New RegistryWorx.Root
    End If
    If RW.RegistryValueExists(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_CLOSE_NAVIGATOR) = False Then
        RW.RegistryCreateValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_CLOSE_NAVIGATOR, _
                ValueValue:=CLng(pCloseNavigationAfterSelect)
    Else
        RW.RegistrySetValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_CLOSE_NAVIGATOR, _
            newvalue:=CLng(pCloseNavigationAfterSelect)
    End If

End Sub

Private Sub Form_Load()

Dim WB As Excel.Workbook
Dim WS As Object

Dim NavTop As Variant
Dim NavLeft As Variant

Dim MeHWnd As Long
Dim XLHWnd As Long


Dim RootNode As MSComctlLib.Node
Dim WBNode As MSComctlLib.Node
Dim WSNode As MSComctlLib.Node

MeHWnd = Me.HWnd
XLHWnd = XL.HWnd
'SetParent MeHWnd, XLHWnd

If RWCreatable = False Then
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' if the user has an old version of RegistryWorx, the
    ' Root may not be creatable. This is tested during
    ' OnConnection. If we can't create RegistryWorx, we
    ' don't do any registry related stuff.
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Exit Sub
End If


If RW Is Nothing Then
    Set RW = New RegistryWorx.Root
End If

NavTop = RW.RegistryGetValue(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP)
If IsNull(NavTop) Then
    NavTop = C_DEFAULT_TOP
Else
    NavTop = CLng(NavTop)
End If

NavLeft = RW.RegistryGetValue(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT)
If IsNull(NavLeft) = True Then
    NavLeft = C_DEFAULT_LEFT
Else
    If NavLeft < 0 Then
        NavLeft = C_DEFAULT_LEFT
    Else
        NavLeft = CLng(NavLeft)
    End If
End If

Me.Top = NavTop
Me.Left = NavLeft


Set RootNode = Me.tvwWorkbooks.Nodes.Add(Text:="All Visibile Workbooks")
RootNode.Expanded = True
RootNode.Tag = "ROOT"
For Each WB In XL.Workbooks
    If HasVisibleWindow(WB:=WB) = True Then
        Set WBNode = Me.tvwWorkbooks.Nodes.Add(relative:=RootNode, relationship:=tvwChild, Text:=WB.Name & " : " & WB.FullName)
        WBNode.Tag = "WB"
        For Each WS In WB.Sheets
            If WS.Visible = xlSheetVisible Then
                Set WSNode = Me.tvwWorkbooks.Nodes.Add(relative:=WBNode, relationship:=tvwChild, Text:=WS.Name)
                WSNode.Tag = "SH"
            End If
        Next WS
    End If
Next WB
End Sub


Private Function HasVisibleWindow(WB As Excel.Workbook) As Boolean

Dim Win As Excel.Window
For Each Win In WB.Windows
    If Win.Visible = True Then
        HasVisibleWindow = True
        Exit Function
    End If
Next Win
        
End Function

Private Sub Form_Terminate()
    
    If RWCreatable = False Then
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' if the user has an old version of RegistryWorx, the
        ' Root may not be creatable. This is tested during
        ' OnConnection. If we can't create RegistryWorx, we
        ' don't do any registry related stuff.
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Exit Sub
    End If
    
    If RW Is Nothing Then
        Set RW = New RegistryWorx.Root
    End If
    
    If RW.RegistryValueExists(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP) = False Then
        RW.RegistryCreateValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP, ValueValue:=CLng(Me.Top)
    End If
    RW.RegistrySetValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_TOP, newvalue:=CLng(Me.Top)
    
    If RW.RegistryValueExists(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT) = False Then
        RW.RegistryCreateValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT, ValueValue:=CLng(Me.Left)
    End If
    RW.RegistrySetValue basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_NAV_LEFT, newvalue:=CLng(Me.Left)
    
    
End Sub

Private Sub tvwWorkbooks_DblClick()
    Dim ND As MSComctlLib.Node
    Dim Tag As String
    Dim WBNode As MSComctlLib.Node
    Dim HideForm As Boolean
    Dim S As String
    Dim VV As Variant
    Dim WBName As String
    
    Set ND = Me.tvwWorkbooks.SelectedItem
    Tag = ND.Tag
    
    Select Case Tag
        Case "ROOT"
            ' do nothing
            HideForm = False
        Case "WB"
            VV = Split(ND.Text, ":")
            If LBound(VV) <= UBound(VV) Then
                VV = Trim(VV(0))
            End If
            VV = Trim(VV)
            XL.Workbooks(VV).Activate
            HideForm = pCloseNavigationAfterSelect
        Case "SH"
            Set WBNode = ND.Parent
            VV = Split(WBNode.Text, ":")
            If LBound(VV) <= UBound(VV) Then
                VV = Trim(VV(0))
            End If
            XL.Workbooks(VV).Activate
            XL.Workbooks(VV).Sheets(ND.Text).Select
            HideForm = pCloseNavigationAfterSelect
            
        Case Else
    End Select
    
    If HideForm = True Then
        Me.Hide
    End If
    
End Sub

Private Sub GetRegistrySettings()

Dim V As Variant

If RWCreatable = False Then
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' if the user has an old version of RegistryWorx, the
    ' Root may not be creatable. This is tested during
    ' OnConnection. If we can't create RegistryWorx, we
    ' don't do any registry related stuff.
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Exit Sub
End If

If RW Is Nothing Then
    Set RW = New RegistryWorx.Root
End If
V = RW.RegistryGetValue(basekey:=HKCU, keyname:=C_REG_KEY, ValueName:=C_CLOSE_NAVIGATOR)
If IsNull(V) = True Then
    V = False
Else
    V = CBool(V)
End If
pCloseNavigationAfterSelect = V

End Sub

