Attribute VB_Name = "modGlobals"
Option Explicit
Option Compare Text
Option Private Module

Public Const C_APP_NAME = "Workbook Command Bar"
Public Const C_CMDBAR_NAME = "Workbook CommandBar"
Public Const C_MSGBOX_TITLE = "Workbook CommandBar"
Public Const C_CONTEXT_CMDBAR_NAME = "Workbook Context"
Public Const C_APP_VERSION = "1.0"
Public Const C_COPYRIGHT = "2007, Charles H Pearson"
Public Const C_EMAIL = "chip@cpearson.com"
Public Const C_WEB_SITE = "www.cpearson.com"
Public Const C_THIS_URL = "www.cpearson.com/Excel/WorkbookCommandBar.aspx"
Public Const C_REG_KEY = "Software\Pearson\WorkbookCommandBar"
Public Const C_LOCATION_VALUE = "CommandBar Location"
Public Const C_TOPLEFT_VALUE = "TopLeft"
Public Const C_CLOSE_NAVIGATOR = "CloseNavigatorOnSelection"
Public Const C_NAV_TOP = "NavigatorPositionTop"
Public Const C_NAV_LEFT = "NavigatorPositionLeft"
Public Const C_TIMER_KILL_ABOUT_FORM = "TimerKillAboutForm"
Public Const C_DEFAULT_TOP = 100
Public Const C_DEFAULT_LEFT = 100
Public Const C_INFO_FACE_ID = 984
Public Const C_REFRESH_FACE_ID = 37
Public Const C_NAVIGATE_FACE_ID = 941
Public Const C_NUM_SPECIAL_CONTROLS = 3

Public XL As Excel.Application
Public RW As RegistryWorx.Root
Public ThisCAI As Office.COMAddIn
Public ThisConnect As WorkbookCommandBar.ExcelConnect

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' If an earlier version of RegistryWorx is in use on the target
' machine, the creation of the Root class may fail. RWCreatable
' indicates TRUE or FALSE indicating if Root is creatable. If
' this gets set to FALSE, no registry functions will take place.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public RWCreatable As Boolean


Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Declare Function SetTimer Lib "user32" (ByVal HWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal HWnd As Long, ByVal nIDEvent As Long) As Long


Public Sub KillFormTimer(ByVal HWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTimer As Long)
    On Error Resume Next
    Unload frmAbout
    KillTimer HWnd, idEvent
End Sub

Public Sub SetRWCreatable()
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' SetRWCreatable
' This sets the RWCreatable flag to TRUE or FALSE indicating
' whether the Root object of RegistryWorx can be created. If
' the Root object fails creation, no registry functions are
' performed.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

On Error Resume Next
Dim RWRoot As RegistryWorx.Root
Err.Clear
Set RWRoot = New RegistryWorx.Root
If Err.Number <> 0 Then
    RWCreatable = False
Else
    RWCreatable = True
End If

Dim FName As String
Dim FNum As Integer
Dim S As String

FName = App.Path & "\" & "Creatable.log"
FNum = FreeFile()
Open FName For Output Access Write As #FNum
S = Format(Now, "dd-mmm-yyyy hh:mm:ss")
S = S & vbCrLf & "RegistryWorx creatable? " & CStr(RWCreatable)
Print #FNum, S
Close #FNum


End Sub



